'This Qbasic program will assemble a source file into a binary
'file.  It's for the 8085.  
'
'Written by: khorton@tech.iupui.edu
'
'Yes it sucks, but it works! ;-)  (besides, I wrote it years ago when
'I didn't have anything else and was assembling by hand!




'INSTRUCTIONS:


A0$ = "NOP@LXI B,@STAX B@INX B@INR B@DCR B@MVI B,@RLC@"
A1$ = "KEV@DAD B@LDAX B@DCX B@INR C@DCR C@MVI C,@RRC@"
A2$ = "???@LXI D,@STAX D@INX D@INR D@DCR D@MVI D,@RAL@"
A3$ = "???@DAD D@LDAX D@DCX D@INR E@DCR E@MVI E,@RAR@"
A4$ = "RIM@LXI H,@SHLD @INX H@INR H@DCR H@MVI H,@DAA@"
A5$ = "???@DAD H@LHLD @DCX H@INR L@DCR L@MVI L,@CMA@"
A6$ = "SIM@LXI SP,@STA @INX SP@INR M@DCR M@MVI M,@STC@"
A7$ = "???@DAD SP@LDA @DCX SP@INR A@DCR A@MVI A,@CMC@"
A8$ = "MOV B,B@MOV B,C@MOV B,D@MOV B,E@MOV B,H@MOV B,L@MOV B,M@MOV B,A@"
A9$ = "MOV C,B@MOV C,C@MOV C,D@MOV C,E@MOV C,H@MOV C,L@MOV C,M@MOV C,A@"
AA$ = "MOV D,B@MOV D,C@MOV D,D@MOV D,E@MOV D,H@MOV D,L@MOV D,M@MOV D,A@"
AB$ = "MOV E,B@MOV E,C@MOV E,D@MOV E,E@MOV E,H@MOV E,L@MOV E,M@MOV E,A@"
AC$ = "MOV H,B@MOV H,C@MOV H,D@MOV H,E@MOV H,H@MOV H,L@MOV H,M@MOV H,A@"
AD$ = "MOV L,B@MOV L,C@MOV L,D@MOV L,E@MOV L,H@MOV L,L@MOV L,M@MOV L,A@"
AE$ = "MOV M,B@MOV M,C@MOV M,D@MOV M,E@MOV M,H@MOV M,L@HLT@MOV M,A@"
AF$ = "MOV A,B@MOV A,C@MOV A,D@MOV A,E@MOV A,H@MOV A,L@MOV A,M@MOV A,A@"
B0$ = "ADD B@ADD C@ADD D@ADD E@ADD H@ADD L@ADD M@ADD A@"
B1$ = "ADC B@ADC C@ADC D@ADC E@ADC H@ADC L@ADC M@ADC A@"
B2$ = "SUB B@SUB C@SUB D@SUB E@SUB H@SUB L@SUB M@SUB A@"
B3$ = "SBB B@SBB C@SBB D@SBB E@SBB H@SBB L@SBB M@SBB A@"
B4$ = "ANA B@ANA C@ANA D@ANA E@ANA H@ANA L@ANA M@ANA A@"
B5$ = "XRA B@XRA C@XRA D@XRA E@XRA H@XRA L@XRA M@XRA A@"
B6$ = "ORA B@ORA C@ORA D@ORA E@ORA H@ORA L@ORA M@ORA A@"
B7$ = "CMP B@CMP C@CMP D@CMP E@CMP H@CMP L@CMP M@CMP A@"
B8$ = "RNZ@POP B@JNZ @JMP @CNZ @PUSH B@ADI @RST 0@"
B9$ = "RZ@RET@JZ @???@CZ @CALL @ACI @RST 1@"
BA$ = "RNC@POP D@JNC @OUT @CNC @PUSH D@SUI @RST 2@"
BB$ = "RC@???@JC @IN @CC @???@SBI @RST 3@"
BC$ = "RPO@POP H@JPO @XTHL@CPO @PUSH H@ANI @RST 4@"
BD$ = "RPE@PCHL@JPE @XCHG@CPE @???@XRI @RST 5@"
BE$ = "RP@POP PSW@JP @DI@CP @PUSH PSW@ORI @RST 6@"
BF$ = "RM@SPHL@JM @EI@CM @???@CPI @RST 7@"
A$ = A0$ + A1$ + A2$ + A3$ + A4$ + A5$ + A6$ + A7$
A$ = A$ + A8$ + A9$ + AA$ + AB$ + AC$ + AD$ + AE$ + AF$
A$ = A$ + B0$ + B1$ + B2$ + B3$ + B4$ + B5$ + B6$ + B7$
A$ = A$ + B8$ + B9$ + BA$ + BB$ + BC$ + BD$ + BE$ + BF$


'ADDRESSING MODES:
'0- NO DATA FOLLOWS
'1- 8-BIT DATA FOLLOWS
'2- 16-BIT DATA FOLLOWS
'    0 1 2 3 4 5 6 7 8 9 A B C D E F 0 1 2 3 4 5 6 7 8 9 A B C D E F
DATA 0,2,0,0,0,0,1,0,2,0,0,0,0,0,1,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,1,0
DATA 0,2,2,0,0,0,1,0,0,0,2,0,0,0,1,0,0,2,2,0,0,0,1,0,0,0,2,0,0,0,1,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,2,2,2,0,1,0,0,0,2,0,2,2,1,0,0,0,2,1,2,0,1,0,0,0,2,1,2,0,1,0
DATA 0,0,2,0,2,0,1,0,0,0,2,0,2,0,1,0,0,0,2,0,2,0,1,0,0,0,2,0,2,0,1,0



'READ IN ALL THE JUNK

DIM INSTRUCT$(256), ADDMODE(256), VARNAME$(255), VARVAL(255)
DIM HIGHESTVAR(20), VARCHAR(20), LABNAME$(255), LABLOC(255)
FOR A = 0 TO 255
READ ADDMODE(A)
NEXT

N = 0
FOR A = 1 TO LEN(A$)
B$ = MID$(A$, A, 1)
C$ = C$ + B$: IF B$ = "@" THEN INSTRUCT$(N) = LEFT$(C$, LEN(C$) - 1): C$ = "": N = N + 1
NEXT



INPUT "INPUT FILENAME"; FL$
INPUT "OUTPUT FILENAME"; FL2$
'FL$ = "CHECK"
'FL2$ = "CHECK.BIN"
PRINT : PRINT
OPEN FL$ FOR INPUT AS 1
OPEN FL2$ FOR OUTPUT AS 2
PRINT "PASS 1"
LOOPB:
SPACEFLAG = 0
LINE$ = ""
A$ = " "
WHILE A$ <> CHR$(10)
IF EOF(1) THEN GOTO PASS2
A$ = INPUT$(1, 1)
IF A$ = " " AND SPACEFLAG = 0 THEN A$ = A$ ELSE LINE$ = LINE$ + A$: SPACEFLAG = -1
WEND


INSTFLAG = 0: VARFLAG = 0: SUBFLAG = 0
FOR A = 1 TO LEN(LINE$)
IF MID$(LINE$, A, 1) = ";" THEN SUBFLAG = -1
IF MID$(LINE$, A, 2) = "*=" THEN VARFLAG = -1
NEXT
IF SUBFLAG = -1 THEN GOSUB SUBROUTINE: GOTO LOOPB
IF VARFLAG = -1 THEN GOSUB VARIABLE: GOTO LOOPB

FOR A = 0 TO 255
IF INSTRUCT$(A) = LEFT$(LINE$, LEN(INSTRUCT$(A))) THEN INSTFLAG = -1: INST = A
NEXT
IF INSTFLAG = -1 THEN GOSUB INSTRUCTION: GOTO LOOPB

A$ = MID$(LINE$, 1, 1)
IF A$ = "|" THEN GOSUB DATTYPE
'PRINT "NOT RECOGNIZED!!!!"; LINE$
GOTO LOOPB


PASS2:
PRINT : PRINT : PRINT : PASS = 2
CLOSE 1
OPEN FL$ FOR INPUT AS 1
COLOR 3
PRINT "PASS 2"
PRINT
LOOPA:
LINE$ = ""
A$ = " "
WHILE A$ <> CHR$(10)
IF EOF(1) THEN GOTO CONTA
A$ = INPUT$(1, 1)
LINE$ = LINE$ + A$
WEND


INSTFLAG = 0: VARFLAG = 0: SUBFLAG = 0
FOR A = 1 TO LEN(LINE$)
IF MID$(LINE$, A, 1) = "=" THEN VARFLAG = -1
IF MID$(LINE$, A, 1) = ";" THEN SUBFLAG = -1
NEXT
IF VARFLAG = -1 THEN GOSUB VARIABLE: GOTO LOOPA
IF SUBFLAG = -1 THEN GOSUB SUBROUTINE2: GOTO LOOPA


FOR A = 0 TO 255
IF INSTRUCT$(A) = LEFT$(LINE$, LEN(INSTRUCT$(A))) THEN INSTFLAG = -1: INST = A
NEXT
IF INSTFLAG = -1 THEN GOSUB INSTRUCTION: GOTO LOOPA

A$ = MID$(LINE$, 1, 1)
IF A$ = "|" THEN GOSUB DATTYPE
'PRINT "NOT RECOGNIZED!!!!"; LINE$
GOTO LOOPA
CONTA:
COLOR 3
FOR A = 0 TO PTRVAR - 1
PRINT "VAR#"; A; "     VARNAME:"; VARNAME$(A); "      VARVAL:"; HEX$(VARVAL(A))
NEXT
PRINT : PRINT
FOR A = 0 TO LABPTR - 1
PRINT "LAB#"; A; "     LABNAME:"; LABNAME$(A); "      LABLOC:"; HEX$(LABLOC(A))
NEXT
PRINT : PRINT
PRINT "ADDRESS:"; MAINADD
'PRINT #2, MKL$(MAINADD - STARTADD);
CLOSE 1
END


VARIABLE:
ER$ = ""
ERRFLAG = 0
COLOR 10
PRINT "VAR: ";
COLOR 15
PRINT LEFT$(LINE$, LEN(LINE$) - 2); "          ";
COLOR 3
FOR A = 1 TO LEN(LINE$)
IF MID$(LINE$, A, 1) = "=" THEN B = A
NEXT
LFT$ = LEFT$(LINE$, B - 1)
RGHT$ = RIGHT$(LINE$, LEN(LINE$) - B)
GOSUB XCHGBASES
IF ER$ <> "" THEN PRINT ER$
FOR A = 0 TO PTRVAR
IF LFT$ = VARNAME$(A) THEN ERRFLAG = -1: PRINT "ERROR: SAME VARIABLE NAME!!"
NEXT
IF LFT$ = "*" THEN ERRFLAG = -1: MAINADD = TTLVAL: PRINT : STARTADD = TTLVAL
IF LFT$ = "*" AND PASS = 2 THEN PRINT #2, MKL$(TTLVAL);
IF LFT$ = "TEMP" THEN TEMPVAR = TTLVAL: ERRFLAG = -1: PRINT
IF ERRFLAG = -1 THEN RETURN
VARNAME$(PTRVAR) = LFT$
VARVAL(PTRVAR) = TTLVAL
PTRVAR = PTRVAR + 1
PRINT
RETURN


XCHGBASES:
TYPE$ = MID$(RGHT$, 1, 1)
IF TYPE$ = "$" THEN GOSUB HEXTYPE
IF TYPE$ = "%" THEN GOSUB BINTYPE
IF TYPE$ = "&" THEN GOSUB OCTTYPE
IF TYPE$ = "'" THEN GOSUB ASCTYPE
IF TYPE$ <> "$" AND TYPE$ <> "%" AND TYPE$ <> "&" AND TYPE$ <> "'" THEN GOSUB DECTYPE
RETURN



HEXTYPE:
HX$ = "0123456789ABCDEF"
RGHT$ = RIGHT$(RGHT$, LEN(RGHT$) - 1)
'PRINT "HEXTYPE-"; RGHT$
HIGHESTVAR = 0
FOR A = 1 TO LEN(RGHT$)
FOR B = 1 TO 16
IF MID$(RGHT$, A, 1) = MID$(HX$, B, 1) THEN HIGHESTVAR = A: VARCHAR(A) = B - 1
NEXT
NEXT
IF HIGHESTVAR = 0 THEN ERRFLAG = -1: ER$ = "ERROR: NOT ENOUGH DIGITS!!": RETURN
IF HIGHESTVAR >= 5 THEN ERRFLAG = -1: ER$ = "ERROR1: TOO MANY DIGITS!!": RETURN
'FOR A = 1 TO HIGHESTVAR
'PRINT "VAL-CHAR"; A; "-"; VARCHAR(A)
'NEXT
N = 0
TTLVAL = 0
FOR A = HIGHESTVAR TO 1 STEP -1
TTLVAL = TTLVAL + VARCHAR(A) * 16 ^ N
N = N + 1
NEXT
'PRINT "TTLVAL="; TTLVAL
RETURN

DECTYPE:
'PRINT "DECTYPE-"; RGHT$
TTLVAL = INT(VAL(RGHT$))
IF TTLVAL < 0 THEN ER$ = "ERROR: # TOO SMALL!!": ERRFLAG = -1
IF TTLVAL >= 65536 THEN ER$ = "ERROR: #TOO BIG!!": ERRFLAG = -1
'PRINT "TTLVAL:"; TTLVAL
RETURN

BINTYPE:
HX$ = "01"
RGHT$ = RIGHT$(RGHT$, LEN(RGHT$) - 1)
'PRINT "BINTYPE-"; RGHT$
HIGHESTVAR = 0
FOR A = 1 TO LEN(RGHT$)
FOR B = 1 TO 2
IF MID$(RGHT$, A, 1) = MID$(HX$, B, 1) THEN HIGHESTVAR = A: VARCHAR(A) = B - 1
NEXT
NEXT
IF HIGHESTVAR = 0 THEN ERRFLAG = -1: ER$ = "ERROR: NOT ENOUGH DIGITS!!": RETURN
IF HIGHESTVAR >= 17 THEN ERRFLAG = -1: ER$ = "ERROR: TOO MANY DIGITS!!": RETURN
'FOR A = 1 TO HIGHESTVAR
'PRINT "VAL-CHAR"; A; "-"; VARCHAR(A)
'NEXT
N = 0
TTLVAL = 0
FOR A = HIGHESTVAR TO 1 STEP -1
TTLVAL = TTLVAL + VARCHAR(A) * 2 ^ N
N = N + 1
NEXT
'PRINT "TTLVAL="; TTLVAL
IF TTLVAL >= 65536 THEN ER$ = "ERROR: # TOO BIG!!": ERRFLAG = -1
RETURN

OCTTYPE:
HX$ = "01234567"
RGHT$ = RIGHT$(RGHT$, LEN(RGHT$) - 1)
'PRINT "OCTTYPE-"; RGHT$
HIGHESTVAR = 0
FOR A = 1 TO LEN(RGHT$)
FOR B = 1 TO 8
IF MID$(RGHT$, A, 1) = MID$(HX$, B, 1) THEN HIGHESTVAR = A: VARCHAR(A) = B - 1
NEXT
NEXT
IF HIGHESTVAR = 0 THEN ERRFLAG = -1: ER$ = "ERROR: NOT ENOUGH DIGITS!!": RETURN
IF HIGHESTVAR >= 7 THEN ERRFLAG = -1: ER$ = "ERROR: TOO MANY DIGITS!!": RETURN
'FOR A = 1 TO HIGHESTVAR
'PRINT "VAL-CHAR"; A; "-"; VARCHAR(A)
'NEXT
N = 0
TTLVAL = 0
FOR A = HIGHESTVAR TO 1 STEP -1
TTLVAL = TTLVAL + VARCHAR(A) * 8 ^ N
N = N + 1
NEXT
'PRINT "TTLVAL="; TTLVAL
IF TTLVAL >= 65536 THEN ER$ = "ERROR: # TOO BIG!!": ERRFLAG = -1
RETURN

ASCTYPE:
RGHT$ = RIGHT$(RGHT$, LEN(RGHT$) - 1)
'PRINT "ASCTYPE-"; RGHT$
TTLVAL = ASC(RGHT$)
RETURN

INSTRUCTION:
ER$ = ""
AM = ADDMODE(INST)
IF AM = 0 THEN GOTO SKIPIT
T$ = MID$(LINE$, LEN(INSTRUCT$(INST)) + 1, LEN(LINE$) - LEN(INSTRUCT$(INST)))
RGHT$ = T$
CHK$ = ""
FOR A = 1 TO LEN(T$)
IF MID$(T$, A, 1) >= CHR$(33) THEN CHK$ = CHK$ + MID$(T$, A, 1)
NEXT
VARFLAG = 0
FOR A = 0 TO LABPTR
IF LABNAME$(A) = CHK$ THEN B = A: VARFLAG = -1
NEXT
IF VARFLAG = -1 THEN RGHT$ = "$" + HEX$(LABLOC(B))
VARFLAG = 0
FOR A = 0 TO PTRVAR
IF VARNAME$(A) = CHK$ THEN B = A: VARFLAG = -1:
NEXT
IF VARFLAG = -1 THEN RGHT$ = "$" + HEX$(VARVAL(B))
ERRFLAG = 0
GOSUB XCHGBASES

IF ERRFLAG = -1 THEN TTLVAL = 0: PRINT ER$;
IF AM = 1 AND TTLVAL >= 256 THEN ER$ = "ERROR: # TOO BIG!": TTLVAL = TTLVAL AND 255
ERRFLAG = 0
SKIPIT:
OLDADD = MAINADD
IF INST <> 8 THEN MAINADD = MAINADD + ADDMODE(INST) + 1 ELSE MAINADD = MAINADD + 2
IF AM = 1 THEN BYTE1 = TTLVAL
IF AM = 2 THEN BYTE2 = INT(TTLVAL / 256): BYTE1 = TTLVAL - BYTE2 * 256
COLOR 7: PRINT "INS: ";

COLOR 15
PRINT USING "\  \"; HEX$(OLDADD); "  ";
IF INST > 15 THEN PRINT HEX$(INST);  ELSE PRINT "0"; HEX$(INST);
IF AM THEN IF BYTE1 > 15 THEN PRINT HEX$(BYTE1);  ELSE PRINT "0"; HEX$(BYTE1);
IF AM = 2 THEN IF BYTE2 > 15 THEN PRINT HEX$(BYTE2);  ELSE PRINT "0"; HEX$(BYTE2);
IF AM THEN T$ = LEFT$(T$, LEN(T$) - 2) ELSE T$ = ""
IF PASS = 2 AND INST <> 8 THEN PRINT #2, CHR$(INST);
IF PASS = 2 AND AM THEN PRINT #2, CHR$(BYTE1);
IF PASS = 2 AND AM = 2 THEN PRINT #2, CHR$(BYTE2);
COLOR 11
PRINT ,
PRINT "   "; INSTRUCT$(INST); T$; "          ";
COLOR 12: PRINT ER$: COLOR 3
RETURN

SUBROUTINE:
ER$ = ""
ERRFLAG = 0
COLOR 3
PRINT "LAB: ";
COLOR 14
FOR A = 1 TO LEN(LINE$)
IF MID$(LINE$, A, 1) = ";" THEN B = A
NEXT
LFT$ = LEFT$(LINE$, B - 1)
PRINT LFT$; "          ",
COLOR 4
FOR A = 0 TO LABPTR
IF LFT$ = LABNAME$(A) THEN ERRFLAG = -1: PRINT "ERROR: SAME LABEL NAME!!"
NEXT
COLOR 3
IF ERRFLAG = -1 THEN RETURN
LABNAME$(LABPTR) = LFT$
LABLOC(LABPTR) = MAINADD
PRINT "   LOCATION: $"; HEX$(MAINADD)
LABPTR = LABPTR + 1
RETURN

SUBROUTINE2:
COLOR 3
PRINT "LAB: ";
COLOR 14
FOR A = 1 TO LEN(LINE$)
IF MID$(LINE$, A, 1) = ";" THEN B = A
NEXT
LFT$ = LEFT$(LINE$, B - 1)
PRINT LFT$; "          "
COLOR 3
RETURN

DATTYPE:
LINE$ = RIGHT$(LINE$, LEN(LINE$) - 1)
LINE$ = LEFT$(LINE$, LEN(LINE$) - 2)
FOR A = 1 TO LEN(LINE$)
A$ = MID$(LINE$, A, 1)
IF PASS = 2 THEN PRINT #2, A$;
MAINADD = MAINADD + 1
PRINT "DAT: "; A$;
NEXT
PRINT
RETURN

